
/******************************************************************************
* MODULE     : compiler.hh
* DESCRIPTION: the heart of the mathemagix compiler
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __COMPILER_HH
#define __COMPILER_HH
#include <list.hh>
#include <context.hh>

#define DEBUG_INSTRUCTIONS 1
#define DEBUG_DECLARATIONS 2
extern int DEBUG_COMPILATION;

generic compile (context& con, generic g, list& errors);

#endif // __COMPILER_HH
