
/******************************************************************************
* MODULE     : foreign.hh
* DESCRIPTION: the mathemagix foreign
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __FOREIGN_HH
#define __FOREIGN_HH
#include <interpreter.hh>

generic bool_or (generic g);
generic bool_xor (generic g);
generic bool_and (generic g);
generic bool_not (generic g);
generic bool_implies (generic g);
generic bool_equivalent (generic g);
generic bool_equal (generic g);
generic bool_not_equal (generic g);
generic bool_output (generic g);

generic int_plus (generic g);
generic int_minus (generic g);
generic int_times (generic g);
generic int_equal (generic g);
generic int_not_equal (generic g);
generic int_less (generic g);
generic int_less_equal (generic g);
generic int_greater (generic g);
generic int_greater_equal (generic g);
generic int_output (generic g);

generic string_concat (generic g);
generic string_equal (generic g);
generic string_not_equal (generic g);
generic string_less (generic g);
generic string_less_equal (generic g);
generic string_greater (generic g);
generic string_greater_equal (generic g);
generic string_output (generic g);

#endif // __FOREIGN_HH
