
/******************************************************************************
* MODULE     : test2.cc
* DESCRIPTION: Test parser
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <file.hh>
#include <mm_parser.hh>
#include <error.hh>

char line[]= "-------------------------------------------------------------\n";

string
input () {
  int i;
  char in[1000];
  cout << "in ] ";
  for (i=0; i<999; i++) {
    cin.get(in[i]);
    if (in[i]=='\n') break;
  }
  in[i]='\0';
  return in;
}

void
parse_string (string s) {
  list errors;
  generic output= mm_parse (s, errors);
  print_errors (errors);
  cout << "out] " << output << "\n";
}

int
main (int argc, char** argv) {
  int i;
  string s;

  for (i=1; i<argc; i++) {
    string arg (argv[i]);
    insert_source (arg, "cmdline");
    cout << "Parsing " << arg << "\n";
    cout << line;
    if (load (arg, s)) cout << "Couldn't open file\n";
    else parse_string (s);
    cout << line;
  }

  if (argc == 1)
    while (TRUE) {
      s= input ();
      if (s == "") break;
      insert_source (s, "cmdline");
      parse_string (s);
    }

  return 0;
}
