
/*  A Bison parser, made from mm_parser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	258
#define	NUMBER	259
#define	STRING	260
#define	ADD	261
#define	BREAK	262
#define	CASE	263
#define	CATCH	264
#define	CONTINUE	265
#define	DO	266
#define	ELSE	267
#define	EXPORT	268
#define	EXTEND	269
#define	FOR	270
#define	FROM	271
#define	GENERATE	272
#define	HAS	273
#define	HIDDEN	274
#define	HOLDS	275
#define	IF	276
#define	IN	277
#define	INFIX	278
#define	IMPORT	279
#define	INHERIT	280
#define	LOOP	281
#define	PREFIX	282
#define	POSTFIX	283
#define	RAISE	284
#define	RETURN	285
#define	STEP	286
#define	THEN	287
#define	TRY	288
#define	UNTIL	289
#define	VALUE	290
#define	WHILE	291
#define	WITH	292
#define	YIELD	293
#define	MACRO	294
#define	ABSTRACT	295
#define	CONCRETE	296
#define	CONSTANT	297
#define	DIRECT	298
#define	EVOLUTIVE	299
#define	EXTERN	300
#define	INDIRECT	301
#define	INLINE	302
#define	INTERN	303
#define	LOCKED	304
#define	METHOD	305
#define	PRIVATE	306
#define	PROTECTED	307
#define	OUTLINE	308
#define	PACKED	309
#define	PUBLIC	310
#define	UNPACKED	311
#define	VARIABLE	312
#define	DEFINE	313
#define	ASSIGN	314
#define	PLUS_ASSIGN	315
#define	MINUS_ASSIGN	316
#define	TIMES_ASSIGN	317
#define	OVER_ASSIGN	318
#define	TYPE	319
#define	INTO	320
#define	MAPSTO	321
#define	LEFT_FLUX	322
#define	RIGHT_FLUX	323
#define	OR	324
#define	BITOR	325
#define	BITXOR	326
#define	AND	327
#define	BITAND	328
#define	NOT	329
#define	IMPLIES	330
#define	EQUIVALENT	331
#define	EQUAL	332
#define	LESS	333
#define	LEQ	334
#define	GREATER	335
#define	GEQ	336
#define	NOT_EQUAL	337
#define	NOT_LESS	338
#define	NOT_LEQ	339
#define	NOT_GREATER	340
#define	NOT_GEQ	341
#define	CAST	342
#define	RANGE	343
#define	PLUS	344
#define	MINUS	345
#define	OPLUS	346
#define	OMINUS	347
#define	TIMES	348
#define	OVER	349
#define	OTIMES	350
#define	OOVER	351
#define	COMPOSE	352
#define	SIGNATURE	353
#define	POWER	354
#define	INC	355
#define	DEC	356
#define	PRIME	357
#define	SIZE	358
#define	ACCESS	359
#define	THIS	360
#define	FOREIGN	361

#line 1 "mm_parser.y"


/******************************************************************************
* MODULE     : mm_parser.y / mm_parser.cc
* DESCRIPTION: The mathemagix parser
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <mm_lexer.hh>
#include <mm_parser.hh>
#include <error.hh>

#define malloc GC_MALLOC
#define free(x)

#define YYSTYPE generic
#define yyparse mm_parse
#define yylex mm_lex
#define yyerror mm_error
#define yylval mm_lval
#define yychar mm_char
#define yydebug mm_debug
#define yynerrs mm_nerrs

static generic mm_parse_result;
static list    mm_parse_warnings;
static list    mm_parse_errors;
static void mm_warning (char* message, generic where);
static void mm_error (char* message);

/******************************************************************************
* Generation of expressions
******************************************************************************/

static generic if_then (generic g_if, generic g_cond, generic g_arg);
static generic sequence (generic g_op, generic g_arg);

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		478
#define	YYFLAG		-32768
#define	YYNTBASE	115

#define YYTRANSLATE(x) ((unsigned)(x) <= 361 ? yytranslate[x] : 177)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   107,
   108,     2,     2,   109,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,   112,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   113,     2,   114,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   110,     2,   111,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     9,    13,    18,    22,    26,    30,    32,
    36,    38,    40,    42,    44,    46,    50,    55,    57,    61,
    65,    69,    70,    73,    76,    81,    83,    85,    89,    93,
    96,    98,   101,   104,   106,   111,   118,   122,   125,   130,
   134,   138,   142,   146,   150,   154,   157,   160,   163,   166,
   169,   172,   175,   176,   180,   186,   190,   194,   198,   202,
   203,   206,   211,   213,   217,   221,   224,   226,   229,   231,
   233,   235,   239,   244,   250,   256,   259,   260,   263,   267,
   270,   272,   274,   281,   284,   289,   293,   298,   304,   310,
   314,   318,   322,   326,   330,   334,   336,   338,   340,   347,
   350,   355,   359,   363,   369,   375,   379,   383,   387,   391,
   395,   399,   401,   405,   409,   411,   415,   417,   421,   422,
   426,   427,   430,   432,   436,   440,   444,   446,   450,   452,
   456,   458,   462,   464,   468,   472,   474,   478,   480,   484,
   486,   489,   491,   495,   499,   501,   505,   509,   513,   517,
   521,   525,   529,   533,   537,   541,   545,   549,   551,   555,
   557,   561,   563,   567,   569,   573,   577,   581,   585,   587,
   591,   595,   599,   603,   607,   609,   612,   615,   618,   621,
   623,   626,   629,   632,   634,   638,   643,   648,   650,   654,
   656,   659,   662,   665,   668,   670,   673,   677,   684,   688,
   690,   693,   696,   699,   701,   705,   710,   715,   717,   721,
   723,   726,   729,   732,   735,   737,   739,   741,   746,   751,
   753,   755,   757,   759,   761,   763,   765,   767,   769,   771,
   773,   775,   777,   779,   781,   783,   785,   787,   789,   792,
   795,   798,   801,   804,   806,   808,   810,   812,   814,   816,
   818,   820,   822,   824,   826,   828,   830,   832,   834,   836,
   838,   840,   842,   844,   846,   848,   850,   852,   854,   856,
   858,   860,   862,   864,   866,   868,   870,   872,   874,   876,
   878,   880,   882
};

static const short yyrhs[] = {   121,
     0,     1,   131,     0,    24,   117,   131,     0,    13,   117,
   131,     0,   118,    64,   143,   131,     0,   118,    64,   130,
     0,   120,    58,   136,     0,   120,    59,   136,     0,   142,
     0,   142,    16,   142,     0,   171,     0,   172,     0,   173,
     0,   175,     0,   176,     0,   107,   119,   108,     0,   118,
   107,   142,   108,     0,   118,     0,   118,   109,   119,     0,
   118,    64,   143,     0,   118,    64,   130,     0,     0,   116,
   121,     0,   122,   121,     0,   122,   110,   121,   111,     0,
   169,     0,   170,     0,    21,   137,    32,     0,   110,   121,
   111,     0,   122,   123,     0,   123,     0,     1,   131,     0,
   138,   131,     0,   135,     0,    21,   137,    32,   125,     0,
    21,   137,    32,   125,    12,   125,     0,   126,    26,   125,
     0,    17,   125,     0,     8,   137,    22,   127,     0,   143,
    58,   136,     0,   143,    59,   136,     0,   143,    60,   136,
     0,   143,    61,   136,     0,   143,    62,   136,     0,   143,
    63,   136,     0,    30,   136,     0,     7,   136,     0,    38,
   136,     0,    30,   131,     0,    10,   131,     0,     7,   131,
     0,    38,   131,     0,     0,    15,   137,   126,     0,    15,
   137,    22,   137,   126,     0,    36,   137,   126,     0,    34,
   137,   126,     0,    31,   137,   126,     0,   110,   128,   111,
     0,     0,    12,   125,     0,   129,    11,   125,   128,     0,
   153,     0,   153,   109,   129,     0,   143,    37,   124,     0,
     6,   124,     0,   112,     0,   112,   131,     0,   125,     0,
   130,     0,   125,     0,    24,   117,   131,     0,   143,    64,
   143,   131,     0,   143,    64,   143,    58,   132,     0,   143,
    64,   143,    59,   132,     0,   169,   116,     0,     0,   133,
   134,     0,   110,   134,   111,     0,   138,   131,     0,   130,
     0,   135,     0,    21,   137,    32,   137,    12,   136,     0,
    17,   136,     0,     8,   137,    16,   127,     0,   126,    26,
   136,     0,   143,    64,   143,   131,     0,   143,    64,   143,
    58,   136,     0,   143,    64,   143,    59,   136,     0,   143,
    58,   136,     0,   143,    59,   136,     0,   143,    60,   136,
     0,   143,    61,   136,     0,   143,    62,   136,     0,   143,
    63,   136,     0,   138,     0,   130,     0,   135,     0,    21,
   137,    32,   137,    12,   137,     0,    17,   137,     0,     8,
   137,    16,   127,     0,   126,    26,   137,     0,   143,    64,
   143,     0,   143,    64,   143,    58,   137,     0,   143,    64,
   143,    59,   137,     0,   143,    58,   137,     0,   143,    59,
   137,     0,   143,    60,   137,     0,   143,    61,   137,     0,
   143,    62,   137,     0,   143,    63,   137,     0,   143,     0,
   139,    67,   143,     0,   143,    68,   140,     0,   143,     0,
   139,    67,   143,     0,   143,     0,   143,    68,   140,     0,
     0,   109,   137,   141,     0,     0,   137,   141,     0,   147,
     0,   147,    69,   144,     0,   147,    70,   145,     0,   147,
    71,   146,     0,   147,     0,   147,    69,   145,     0,   147,
     0,   147,    70,   144,     0,   147,     0,   147,    71,   146,
     0,   150,     0,   150,    72,   148,     0,   150,    73,   149,
     0,   150,     0,   150,    72,   148,     0,   150,     0,   150,
    73,   149,     0,   151,     0,    74,   151,     0,   152,     0,
   152,    75,   152,     0,   152,    76,   152,     0,   153,     0,
   153,    77,   153,     0,   153,    78,   153,     0,   153,    79,
   153,     0,   153,    80,   153,     0,   153,    81,   153,     0,
   153,    82,   153,     0,   153,    83,   153,     0,   153,    84,
   153,     0,   153,    85,   153,     0,   153,    86,   153,     0,
   153,    18,   153,     0,   153,    20,   153,     0,   154,     0,
   153,    87,   154,     0,   155,     0,   154,    65,   155,     0,
   156,     0,   156,    88,   156,     0,   157,     0,   156,    89,
   157,     0,   156,    90,   157,     0,   156,    91,   157,     0,
   156,    92,   157,     0,   158,     0,   157,    93,   158,     0,
   157,    94,   158,     0,   157,    95,   158,     0,   157,    96,
   158,     0,   157,    97,   158,     0,   159,     0,    90,   158,
     0,   100,   158,     0,   101,   158,     0,   103,   158,     0,
   160,     0,   160,   164,     0,   170,   164,     0,    98,   164,
     0,   161,     0,   160,   104,   161,     0,   160,   107,   142,
   108,     0,   160,   113,   142,   114,     0,   162,     0,   162,
    99,   162,     0,   163,     0,   162,   100,     0,   162,   101,
     0,   162,    74,     0,   162,   102,     0,   168,     0,   107,
   108,     0,   107,   137,   108,     0,   107,   137,   109,   137,
   141,   108,     0,   113,   142,   114,     0,   165,     0,   165,
   164,     0,   170,   164,     0,    98,   164,     0,   166,     0,
   165,   104,   166,     0,   165,   107,   142,   108,     0,   165,
   113,   142,   114,     0,   167,     0,   167,    99,   167,     0,
   168,     0,   167,   100,     0,   167,   101,     0,   167,    74,
     0,   167,   102,     0,   171,     0,     4,     0,     5,     0,
   106,   171,    22,   171,     0,   106,     5,    22,   171,     0,
    44,     0,    45,     0,    47,     0,    48,     0,    49,     0,
    50,     0,    51,     0,    52,     0,    53,     0,    55,     0,
    40,     0,    41,     0,    42,     0,    43,     0,    46,     0,
    54,     0,    56,     0,    57,     0,     3,     0,    27,   172,
     0,    27,   176,     0,    28,   174,     0,    23,   175,     0,
    23,   176,     0,   105,     0,   103,     0,    74,     0,   100,
     0,   101,     0,   102,     0,   173,     0,    74,     0,   100,
     0,   101,     0,    67,     0,    68,     0,    69,     0,    70,
     0,    71,     0,    72,     0,    73,     0,    75,     0,    76,
     0,    77,     0,    78,     0,    79,     0,    80,     0,    81,
     0,    82,     0,    83,     0,    84,     0,    85,     0,    86,
     0,    88,     0,    89,     0,    91,     0,    93,     0,    94,
     0,    95,     0,    96,     0,    97,     0,    99,     0,    90,
     0,    92,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    89,    96,    97,    98,    99,   100,   101,   102,   105,   106,
   109,   110,   111,   112,   113,   114,   116,   119,   120,   123,
   124,   127,   128,   129,   130,   134,   135,   136,   140,   141,
   144,   151,   152,   153,   154,   155,   156,   157,   158,   159,
   160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
   170,   171,   174,   175,   176,   177,   178,   179,   182,   185,
   186,   187,   190,   191,   194,   195,   198,   199,   202,   203,
   206,   207,   208,   209,   210,   211,   214,   215,   218,   226,
   227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   248,   249,   250,   251,   252,
   253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
   263,   266,   267,   268,   271,   272,   275,   276,   279,   280,
   283,   284,   291,   292,   293,   294,   297,   298,   301,   302,
   305,   306,   309,   310,   311,   314,   315,   318,   319,   322,
   323,   326,   327,   328,   331,   332,   333,   334,   335,   336,
   337,   338,   339,   340,   341,   342,   343,   350,   351,   354,
   355,   358,   359,   362,   363,   364,   365,   366,   369,   370,
   371,   372,   373,   374,   377,   378,   379,   380,   381,   388,
   389,   390,   391,   394,   395,   396,   397,   401,   402,   405,
   406,   407,   408,   409,   412,   413,   415,   416,   418,   422,
   423,   424,   425,   428,   429,   430,   431,   435,   436,   439,
   440,   441,   442,   443,   446,   447,   448,   449,   450,   457,
   458,   459,   460,   461,   462,   463,   464,   465,   466,   469,
   470,   471,   472,   473,   474,   475,   476,   483,   484,   485,
   486,   487,   488,   489,   492,   493,   494,   495,   498,   501,
   502,   503,   504,   507,   508,   509,   510,   511,   512,   513,
   514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
   524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
   534,   537,   538
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"NUMBER","STRING","ADD","BREAK","CASE","CATCH","CONTINUE","DO","ELSE","EXPORT",
"EXTEND","FOR","FROM","GENERATE","HAS","HIDDEN","HOLDS","IF","IN","INFIX","IMPORT",
"INHERIT","LOOP","PREFIX","POSTFIX","RAISE","RETURN","STEP","THEN","TRY","UNTIL",
"VALUE","WHILE","WITH","YIELD","MACRO","ABSTRACT","CONCRETE","CONSTANT","DIRECT",
"EVOLUTIVE","EXTERN","INDIRECT","INLINE","INTERN","LOCKED","METHOD","PRIVATE",
"PROTECTED","OUTLINE","PACKED","PUBLIC","UNPACKED","VARIABLE","DEFINE","ASSIGN",
"PLUS_ASSIGN","MINUS_ASSIGN","TIMES_ASSIGN","OVER_ASSIGN","TYPE","INTO","MAPSTO",
"LEFT_FLUX","RIGHT_FLUX","OR","BITOR","BITXOR","AND","BITAND","NOT","IMPLIES",
"EQUIVALENT","EQUAL","LESS","LEQ","GREATER","GEQ","NOT_EQUAL","NOT_LESS","NOT_LEQ",
"NOT_GREATER","NOT_GEQ","CAST","RANGE","PLUS","MINUS","OPLUS","OMINUS","TIMES",
"OVER","OTIMES","OOVER","COMPOSE","SIGNATURE","POWER","INC","DEC","PRIME","SIZE",
"ACCESS","THIS","FOREIGN","'('","')'","','","'{'","'}'","';'","'['","']'","Program",
"D0","IE","Var","Vars","TypeDecl","Dl","Mod","Db2","Db","C0","Conds","Cases",
"Casel","Among","WithAdd","Sep","Cw","Cd","Cl","Cb","EC","E0","E1","Lflux","Rflux",
"Es2","Es","F0","Ors","Bitors","Bitxors","F1","Ands","Bitands","F2","F3","F4",
"T0","T1","T2","T3","T4","T5","R0","R1","R2","R3","R4","S0","S1","S2","S3","S4",
"DeclMod","TypeMod","Id","Prefix","OnlyPost","Postfix","Infix","Minus", NULL
};
#endif

static const short yyr1[] = {     0,
   115,   116,   116,   116,   116,   116,   116,   116,   117,   117,
   118,   118,   118,   118,   118,   118,   118,   119,   119,   120,
   120,   121,   121,   121,   121,   122,   122,   122,   123,   123,
   124,   125,   125,   125,   125,   125,   125,   125,   125,   125,
   125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
   125,   125,   126,   126,   126,   126,   126,   126,   127,   128,
   128,   128,   129,   129,   130,   130,   131,   131,   132,   132,
   133,   133,   133,   133,   133,   133,   134,   134,   135,   136,
   136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
   136,   136,   136,   136,   136,   137,   137,   137,   137,   137,
   137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
   137,   138,   138,   138,   139,   139,   140,   140,   141,   141,
   142,   142,   143,   143,   143,   143,   144,   144,   145,   145,
   146,   146,   147,   147,   147,   148,   148,   149,   149,   150,
   150,   151,   151,   151,   152,   152,   152,   152,   152,   152,
   152,   152,   152,   152,   152,   152,   152,   153,   153,   154,
   154,   155,   155,   156,   156,   156,   156,   156,   157,   157,
   157,   157,   157,   157,   158,   158,   158,   158,   158,   159,
   159,   159,   159,   160,   160,   160,   160,   161,   161,   162,
   162,   162,   162,   162,   163,   163,   163,   163,   163,   164,
   164,   164,   164,   165,   165,   165,   165,   166,   166,   167,
   167,   167,   167,   167,   168,   168,   168,   168,   168,   169,
   169,   169,   169,   169,   169,   169,   169,   169,   169,   170,
   170,   170,   170,   170,   170,   170,   170,   171,   171,   171,
   171,   171,   171,   171,   172,   172,   172,   172,   173,   174,
   174,   174,   174,   175,   175,   175,   175,   175,   175,   175,
   175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
   175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
   175,   176,   176
};

static const short yyr2[] = {     0,
     1,     2,     3,     3,     4,     3,     3,     3,     1,     3,
     1,     1,     1,     1,     1,     3,     4,     1,     3,     3,
     3,     0,     2,     2,     4,     1,     1,     3,     3,     2,
     1,     2,     2,     1,     4,     6,     3,     2,     4,     3,
     3,     3,     3,     3,     3,     2,     2,     2,     2,     2,
     2,     2,     0,     3,     5,     3,     3,     3,     3,     0,
     2,     4,     1,     3,     3,     2,     1,     2,     1,     1,
     1,     3,     4,     5,     5,     2,     0,     2,     3,     2,
     1,     1,     6,     2,     4,     3,     4,     5,     5,     3,
     3,     3,     3,     3,     3,     1,     1,     1,     6,     2,
     4,     3,     3,     5,     5,     3,     3,     3,     3,     3,
     3,     1,     3,     3,     1,     3,     1,     3,     0,     3,
     0,     2,     1,     3,     3,     3,     1,     3,     1,     3,
     1,     3,     1,     3,     3,     1,     3,     1,     3,     1,
     2,     1,     3,     3,     1,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     1,     3,     1,
     3,     1,     3,     1,     3,     3,     3,     3,     1,     3,
     3,     3,     3,     3,     1,     2,     2,     2,     2,     1,
     2,     2,     2,     1,     3,     4,     4,     1,     3,     1,
     2,     2,     2,     2,     1,     2,     3,     6,     3,     1,
     2,     2,     2,     1,     3,     4,     4,     1,     3,     1,
     2,     2,     2,     2,     1,     1,     1,     4,     4,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
     2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1
};

static const short yydefact[] = {     0,
     0,   238,   121,    53,     0,   121,     0,     0,   230,   231,
   232,   233,   220,   221,   234,   222,   223,   224,   225,   226,
   227,   228,   235,   229,   236,   237,   254,   255,   256,   257,
   258,   259,   260,   246,   261,   262,   263,   264,   265,   266,
   267,   268,   269,   270,   271,   272,   273,   274,   282,   275,
   283,   276,   277,   278,   279,   280,   281,   247,   248,   249,
   245,   244,     0,     0,     0,     0,     1,     0,    26,    27,
    11,    12,    13,    14,    15,    67,     2,   216,   217,     0,
    53,    53,    53,    53,    53,    53,    53,     0,     0,     0,
     0,     0,     0,     0,    53,     0,    53,     0,     0,    97,
    98,   119,    96,     0,     9,   112,   123,   133,   140,   142,
   145,   158,   160,   162,   164,   169,   175,   180,   184,   188,
   190,   195,     0,   215,     0,   242,   243,     0,   239,   240,
   251,   252,   253,   250,   241,    18,     0,    23,     0,    53,
    53,    53,     0,    24,    68,     0,     0,    31,    66,     0,
    53,   100,     0,    53,    53,    53,   141,   176,     0,   183,
   200,   204,   208,   210,     0,   177,   178,   179,     0,     0,
   196,     0,     0,    53,    53,     0,     0,    53,   121,    53,
    53,    71,     0,     0,     0,    34,     0,   112,     0,     0,
     4,    53,    53,   122,     0,    53,     0,    53,    53,    53,
    53,    53,    53,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    53,    53,   181,
   193,     0,   191,   192,   194,   182,    28,     3,     0,    16,
     6,    20,     0,    53,    53,    53,     0,    81,    82,     7,
     0,   112,     8,     0,     0,    30,     0,    53,    54,    53,
    58,    57,    56,   203,     0,    53,    53,   201,   213,     0,
   211,   212,   214,   202,     0,     0,   197,    53,    32,    51,
    47,     0,    50,    38,   112,     0,     0,    49,    46,    52,
    48,     0,    78,    79,    33,    53,    53,    53,    53,    53,
    53,     0,    76,   199,   102,   119,   113,    10,    65,   106,
   107,   108,   109,   110,   111,   103,   114,   117,   124,   127,
   125,   129,   126,   131,   134,   136,   135,   138,   143,   144,
   156,   157,   146,   147,   148,   149,   150,   151,   152,   153,
   154,   155,   159,   161,   163,   165,   166,   167,   168,   170,
   171,   172,   173,   174,   185,     0,     0,   189,    19,     5,
    17,     0,    84,     0,    53,    80,    53,    53,    53,    53,
    53,    53,     0,    25,    29,    60,   101,    53,     0,   205,
     0,     0,   209,   219,   218,   119,     0,     0,    72,    37,
    40,    41,    42,    43,    44,    45,     0,   120,    53,    53,
     0,     0,     0,     0,     0,     0,   186,   187,     0,    53,
    86,    90,    91,    92,    93,    94,    95,     0,     0,     0,
     0,    63,    55,    53,   206,   207,     0,    39,    35,     0,
     0,    73,   104,   105,   118,   128,   130,   132,   137,   139,
    85,     0,    53,    53,    87,    61,    59,     0,     0,    99,
   198,     0,    69,    70,    74,   112,    75,    53,    88,    89,
    60,    64,    36,    83,    62,     0,     0,     0
};

static const short yydefgoto[] = {   476,
    64,    98,    65,   137,    66,    67,    68,   148,   149,   182,
    99,   387,   430,   431,   100,    77,   465,   184,   185,   101,
   260,   102,   103,   104,   327,   194,   105,   106,   329,   331,
   333,   107,   335,   337,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   160,   161,
   162,   163,   122,    69,   123,   124,    72,    73,   135,    74,
    75
};

static const short yypact[] = {  2523,
   -43,-32768,  1464,  2019,  2683,  1464,   366,   143,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  2721,  1150,   -52,   -30,-32768,  1038,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -43,-32768,-32768,-32768,  2620,
  2019,  2019,  2019,  2019,  2019,  2019,  2019,  2368,  2368,   580,
  2368,  2368,  2368,    33,  1575,   725,  1259,   -43,    47,-32768,
-32768,   -33,-32768,    34,    78,   646,    -7,   -14,-32768,    35,
   483,    43,-32768,   137,   238,-32768,-32768,   492,-32768,    40,
-32768,-32768,   580,-32768,    92,-32768,-32768,   -43,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -93,    21,-32768,  2211,  1686,
  2130,  2130,  1355,-32768,-32768,  1355,  2620,-32768,-32768,   116,
   439,-32768,   117,   402,   402,   402,-32768,-32768,   580,-32768,
  2436,-32768,    44,-32768,   580,-32768,-32768,-32768,   147,   148,
-32768,    27,   -43,  1797,  2019,   -43,   947,  2019,  1464,  1797,
  1797,-32768,   139,   725,    62,-32768,   -43,   446,  2626,    61,
-32768,  2019,  2019,-32768,  2279,  1908,  2620,  2019,  2019,  2019,
  2019,  2019,  2019,  2279,  2279,  2279,  2279,  2279,  2279,  2279,
  2368,  2368,  2368,  2368,  2368,  2368,  2368,  2368,  2368,  2368,
  2368,  2368,  2368,  2368,  2368,  2368,  2368,  2368,  2368,  2368,
  2368,  2368,  2368,  2368,  2368,  2368,   321,  1686,  1259,-32768,
-32768,   321,-32768,-32768,-32768,-32768,-32768,-32768,  2721,-32768,
    93,   -24,    68,  2019,  2130,  2019,   155,-32768,-32768,-32768,
   -43,   727,-32768,    73,    74,-32768,    83,  2019,-32768,  2019,
-32768,-32768,-32768,-32768,   416,  1686,  1259,-32768,-32768,   416,
-32768,-32768,-32768,-32768,   100,   100,-32768,  2019,-32768,-32768,
-32768,   181,-32768,-32768,   597,   178,   -43,-32768,-32768,-32768,
-32768,   947,-32768,-32768,-32768,  2130,  2130,  2130,  2130,  2130,
  2130,  2279,-32768,-32768,-32768,   -33,   170,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    97,-32768,   171,-32768,   169,
-32768,   172,-32768,   175,-32768,   168,-32768,   182,-32768,-32768,
   161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
   161,   161,    43,-32768,   -66,   238,   238,   238,   238,-32768,
-32768,-32768,-32768,-32768,-32768,   151,   146,   167,-32768,-32768,
-32768,   235,-32768,   230,  2130,-32768,  2130,  2130,  2130,  2130,
  2130,  2130,  2279,-32768,-32768,  2347,-32768,   402,   251,-32768,
   157,   156,   322,-32768,-32768,   -33,    83,   947,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -40,-32768,  2019,  2019,
  2279,  2279,  2279,  2279,  2279,  2279,-32768,-32768,    83,  2019,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -38,   947,   160,
   261,    13,-32768,  2019,-32768,-32768,   166,-32768,   263,   836,
   836,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   267,  2130,  2130,-32768,-32768,-32768,   947,  2368,-32768,
-32768,   947,-32768,-32768,-32768,   746,-32768,  2130,-32768,-32768,
  2347,-32768,-32768,-32768,-32768,   280,   282,-32768
};

static const short yypgoto[] = {-32768,
    94,    -2,   -57,    37,-32768,   -37,   -63,   141,    99,  -120,
     6,  -367,  -173,  -159,   271,   -61,  -130,-32768,   138,   177,
   -76,    -4,   234,-32768,   -84,  -311,   -75,   -88,   -77,   -83,
   -86,  -205,   -78,   -73,  -200,   252,   -53,  -174,   114,   119,
   120,  -196,   165,-32768,-32768,   113,   118,-32768,   -28,-32768,
    80,    82,    88,   -85,     7,   213,   357,   361,-32768,   367,
    63
};


#define	YYLAST		2828


static const short yytable[] = {   125,
   330,   332,   334,   128,   408,   136,    70,   188,   336,   338,
   189,   139,   197,   140,   145,   249,   147,   440,   441,   453,
   454,   190,   228,   229,   230,   231,   138,   141,   142,   438,
   144,   356,   357,   358,   359,     2,   191,   169,   341,   342,
   343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
   252,   451,   262,   262,   140,     5,   294,   209,   210,     7,
     8,   206,   207,   208,   253,   263,   248,   127,    76,   130,
    70,    76,   192,    76,    70,   193,   150,   151,   152,   153,
   154,   155,   156,   147,   437,   262,    70,    76,   295,   240,
   172,   262,   262,   196,   246,   188,   165,   291,   189,   225,
   195,   183,     2,   299,   301,   264,   317,   226,   265,   211,
   212,   289,   290,   241,   293,   326,   328,   279,   298,   300,
   318,   459,     5,   247,   165,   305,     7,     8,   250,   165,
   274,   267,   278,   147,   287,   288,   284,    62,   242,   243,
   244,   245,   280,   281,   282,   283,   257,   257,   270,    70,
   -21,   -21,    70,    70,   409,   410,   269,   339,   340,   271,
   272,   273,   366,   367,   302,   165,   262,   165,   285,   286,
   292,   165,   304,   296,   314,   371,   297,   164,   373,   257,
   375,   400,   183,   384,   385,   257,   257,   315,   316,   183,
   370,   136,   386,   320,   321,   322,   323,   324,   325,   376,
   391,   392,   397,    70,    62,   164,   332,   330,   334,   398,
   164,   432,    71,   295,   336,   338,   131,   262,   262,   262,
   262,   262,   262,   407,   227,   228,   229,   230,   231,   401,
   402,   403,   404,   405,   406,   399,  -116,   412,   411,   415,
   241,   413,   132,   133,    60,   414,   164,   225,   164,   372,
   419,   374,   164,   158,   416,   166,   167,   168,   417,   418,
   257,   420,   434,   388,   435,   389,   243,   244,   245,   436,
   457,   458,   186,   461,   462,    71,    71,   439,   468,   477,
    71,   478,   313,   396,   432,   369,   262,   266,   262,   262,
   262,   262,   262,   262,   428,   319,   432,   475,   421,   472,
   422,   423,   424,   425,   426,   427,   170,   183,   456,   295,
   467,   257,   257,   257,   257,   257,   257,   259,   259,   463,
   463,   303,   328,     2,    78,    79,   445,   448,   446,   187,
   232,   233,   234,   235,   236,   447,   449,   471,   353,   157,
   295,   473,   450,     5,   354,   442,   355,     7,     8,   365,
   259,   466,   466,   186,   390,    71,   259,   259,    71,   368,
   186,   393,   164,   129,   262,   262,   455,   164,   134,   295,
     0,   126,     0,   295,   261,   261,   469,   470,     0,   262,
   257,     0,   257,   257,   257,   257,   257,   257,     0,     0,
     0,   474,     0,   433,     0,   279,   360,   361,   362,   363,
   364,    71,     0,   183,   443,   444,     0,   261,     0,   251,
   187,   258,   258,   261,   261,   452,    82,   187,     2,    78,
    79,   281,   282,   283,     0,    62,    94,    95,     0,   460,
     0,   259,    85,    97,   183,    86,     0,    87,     5,    34,
     0,     0,     7,     8,   258,   183,   183,     0,     0,     0,
   258,   258,     0,    82,     0,    49,     0,    51,   257,   257,
   268,    71,     0,   183,     0,    58,    59,   183,    61,    85,
     0,     0,    86,   257,    87,     0,     0,     0,   186,     0,
     0,     0,   259,   259,   259,   259,   259,   259,   261,     0,
     0,     0,     0,     0,     2,    78,    79,   394,   395,     0,
   213,     0,   214,   306,   307,   308,   309,   310,   311,   312,
     0,     0,  -115,   205,     5,     0,     0,     0,     7,     8,
    62,    94,     0,     0,     0,   258,     0,     0,     0,     0,
     0,     9,    10,    11,    12,   187,     0,    15,     0,   261,
   261,   261,   261,   261,   261,    23,     0,    25,    26,     0,
     0,   259,     0,   259,   259,   259,   259,   259,   259,   215,
   216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     0,     0,     0,     0,   186,     0,   258,   258,   258,   258,
   258,   258,     2,    78,    79,     0,     0,     0,     0,   159,
     0,     0,     0,     0,     0,   237,    62,    94,   238,     0,
     0,     0,     5,     0,   239,   186,     7,     8,   261,     0,
   261,   261,   261,   261,   261,   261,   186,   186,     0,     9,
    10,    11,    12,     0,     0,    15,     0,     0,     0,   259,
   259,   187,     0,    23,   186,    25,    26,     0,   186,     0,
     0,     0,     0,     0,   259,   258,     0,   258,   258,   258,
   258,   258,   258,     0,   306,   307,   308,   309,   310,   311,
     0,     0,   187,  -115,   205,     0,     0,     0,     0,     0,
     0,     0,     0,   187,   187,     0,     0,   159,     0,     0,
     0,     0,   197,     0,    62,    94,   261,   261,     0,     0,
     0,   187,     0,     0,     0,   187,     0,     0,     0,     0,
     0,   261,     0,   198,   199,   200,   201,   202,   203,   204,
   464,   464,  -115,   205,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   258,   258,   173,     0,     2,    78,    79,
     0,   174,   175,     0,   176,     0,     0,     0,   258,    82,
     0,   177,     0,     0,     0,   178,     0,     5,   179,     0,
   -53,     7,     8,     0,   180,    85,     0,     0,    86,     0,
    87,     0,   181,   197,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,   197,     0,   377,   378,   379,   380,   381,   382,
   383,     0,     0,  -115,   205,     0,     0,     0,    88,     0,
     0,     0,     0,   306,   307,   308,   309,   310,   311,     0,
     0,     0,  -115,   205,    89,     0,     0,     0,     0,     0,
     0,     0,    90,     0,    91,    92,     0,    93,     0,    62,
    94,    95,     0,     0,    96,   -77,   173,    97,     2,    78,
    79,    80,   174,   175,     0,   176,     0,     0,     0,     0,
    82,     0,   177,     0,     0,     0,   178,     0,     5,     0,
     0,   -53,     7,     8,     0,   180,    85,     0,     0,    86,
     0,    87,     0,   181,     0,     9,    10,    11,    12,     0,
     0,    15,     0,     0,     0,     0,     0,     0,     0,    23,
     0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    88,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
     0,     0,     0,    90,     0,    91,    92,     0,    93,     0,
    62,    94,    95,     0,     0,    96,     0,   173,    97,     2,
    78,    79,     0,   174,   175,     0,   176,     0,     0,     0,
     0,    82,     0,   177,     0,     0,     0,   178,     0,     5,
     0,     0,   -53,     7,     8,     0,   180,    85,     0,     0,
    86,     0,    87,     0,   181,     0,     9,    10,    11,    12,
     0,     0,    15,     0,     0,     0,     0,     0,     0,     0,
    23,     0,    25,    26,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    88,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    89,   -22,     1,     0,
     2,     0,     0,     0,    90,     0,    91,    92,     0,    93,
     3,    62,    94,    95,     0,     0,    96,     0,     4,    97,
     5,     6,     0,     0,     7,     8,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    46,     0,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,     0,    57,    58,    59,    60,
    61,     0,    62,     0,    63,     0,     0,   143,   -22,   -22,
     1,     0,     2,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     3,     0,     0,     0,     0,     0,     0,     0,
     4,     0,     5,     6,     0,     0,     7,     8,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,     0,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,     0,    57,    58,
    59,    60,    61,     0,    62,     0,    63,     0,     0,     0,
   -22,     2,    78,    79,    80,     0,    81,     0,     0,     0,
     0,     0,     0,    82,     0,    83,     0,     0,     0,    84,
     0,     5,     0,     0,     0,     7,     8,     0,     0,    85,
     0,     0,    86,     0,    87,     0,     0,     0,     9,    10,
    11,    12,     0,     0,    15,     0,     0,     0,     0,     0,
     0,     0,    23,     0,    25,    26,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    88,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    89,     0,
     0,     0,     0,     0,     0,     1,    90,     2,    91,    92,
     0,    93,     0,    62,    94,    95,     0,     3,    96,     0,
     0,    97,  -121,     0,     0,     4,     0,     5,     6,     0,
     0,     7,     8,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,     0,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,     0,    57,    58,    59,    60,    61,     0,    62,
     0,    63,     0,     0,     0,   -22,     2,    78,    79,    80,
     0,    81,     0,     0,     0,     0,     0,     0,    82,     0,
    83,     0,     0,     0,    84,     0,     5,     0,     0,   -53,
     7,     8,     0,     0,    85,     0,     0,    86,     0,    87,
     0,     0,     0,     9,    10,    11,    12,     0,     0,    15,
     0,     0,     0,     0,     0,     0,     0,    23,     0,    25,
    26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    88,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    89,     0,     0,     0,     0,     0,     0,
     0,    90,     0,    91,    92,     0,    93,     0,    62,    94,
    95,     0,     0,    96,     0,     0,    97,     2,    78,    79,
    80,     0,    81,     0,     0,     0,     0,     0,     0,    82,
     0,    83,     0,     0,     0,    84,     0,     5,     0,     0,
     0,     7,     8,     0,     0,    85,     0,     0,    86,     0,
    87,     0,     0,     0,     9,    10,    11,    12,     0,     0,
    15,     0,     0,     0,     0,     0,     0,     0,    23,     0,
    25,    26,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    88,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    89,     0,     0,     0,     0,     0,
     0,     0,    90,     0,    91,    92,     0,    93,     0,    62,
    94,    95,   171,     0,    96,     0,     0,    97,     2,    78,
    79,    80,     0,    81,     0,     0,     0,     0,     0,     0,
    82,     0,    83,     0,     0,     0,    84,     0,     5,     0,
     0,     0,     7,     8,     0,     0,    85,     0,     0,    86,
     0,    87,     0,     0,     0,     9,    10,    11,    12,     0,
     0,    15,     0,     0,     0,     0,     0,     0,     0,    23,
     0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    88,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
     0,     0,     0,    90,     0,    91,    92,     0,    93,     0,
    62,    94,    95,  -121,     0,    96,     0,     0,    97,     2,
    78,    79,    80,     0,   254,     0,     0,     0,     0,     0,
     0,    82,     0,   255,     0,     0,     0,   256,     0,     5,
     0,     0,     0,     7,     8,     0,     0,    85,     0,     0,
    86,     0,    87,     0,     0,     0,     9,    10,    11,    12,
     0,     0,    15,     0,     0,     0,     0,     0,     0,     0,
    23,     0,    25,    26,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    88,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    89,     0,     0,     0,
     0,     0,     0,     0,    90,     0,    91,    92,     0,    93,
     0,    62,    94,    95,     0,     0,    96,     0,    76,    97,
     2,    78,    79,    80,     0,    81,     0,     0,     0,     0,
     0,     0,    82,     0,    83,     0,     0,     0,    84,     0,
     5,     0,     0,     0,     7,     8,     0,     0,    85,     0,
     0,    86,     0,    87,     0,     0,     0,     9,    10,    11,
    12,     0,     0,    15,     0,     0,     0,     0,     0,     0,
     0,    23,     0,    25,    26,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    88,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    89,     0,     0,
     0,     0,     0,     0,     0,    90,     0,    91,    92,     0,
    93,     0,    62,    94,    95,     0,     0,    96,     0,  -121,
    97,     2,    78,    79,    80,     0,    81,     0,     0,     0,
     0,     0,     0,    82,     0,    83,     0,     0,     0,    84,
     0,     5,     0,     0,     0,     7,     8,     0,     0,    85,
     0,     0,    86,     0,    87,     0,     0,     0,     9,    10,
    11,    12,     0,     0,    15,     0,     0,     0,     0,     0,
     0,     0,    23,     0,    25,    26,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    88,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    89,     0,
     0,     0,     0,     0,     0,     0,    90,     0,    91,    92,
     0,    93,     0,    62,    94,    95,     0,     0,    96,     0,
     0,    97,     2,    78,    79,    80,     0,   254,     0,     0,
     0,     0,     0,     0,    82,     0,   255,     0,     0,     0,
   256,     0,     5,     0,     0,     0,     7,     8,     0,     0,
    85,     0,     0,    86,     0,    87,     0,     0,     0,     9,
    10,    11,    12,     0,     0,    15,     0,     0,     0,     0,
     0,     0,     0,    23,     0,    25,    26,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    88,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     2,    78,    79,    80,     0,     0,    89,
     0,     0,     0,     0,     0,     0,     0,    90,     0,    91,
    92,     0,    93,     5,    62,    94,    95,     7,     8,    96,
     0,     0,    97,     0,     0,     0,     0,     0,     0,     0,
     9,    10,    11,    12,     0,     0,    15,     0,     0,     0,
     0,     0,     0,     0,    23,     0,    25,    26,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     2,    78,    79,    88,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    89,     5,     0,     0,     0,     7,     8,     0,    90,     0,
    91,    92,     0,    93,     0,    62,    94,    95,     9,    10,
    11,    12,     0,    97,    15,     0,     0,     0,     0,     0,
     0,     0,    23,     0,    25,    26,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
    78,    79,    88,     0,     0,     0,     0,     0,   429,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    89,     5,
     2,    78,    79,     7,     8,     0,    90,     0,    91,    92,
     0,    93,     0,    62,    94,    95,     9,    10,    11,    12,
     5,    97,    15,     0,     7,     8,     0,     0,     0,     0,
    23,     0,    25,    26,     0,     0,     0,     9,    10,    11,
    12,     0,     0,    15,     0,     0,     0,     0,     0,     0,
     0,    23,     0,    25,    26,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    89,     0,     2,    78,
    79,     0,     0,     0,    90,     0,    91,    92,     0,    93,
     0,    62,    94,    95,     0,     0,     0,    89,     5,    97,
     0,     0,     7,     8,     0,    90,     0,    91,    92,     0,
    93,     0,    62,    94,    95,     9,    10,    11,    12,     0,
    97,    15,     0,     0,     0,     0,     0,     0,     0,    23,
     0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   -22,     1,     0,     2,     0,     0,     0,     0,
     0,     0,     0,   159,     0,     3,     0,     0,     0,   275,
    62,    94,   276,     4,     0,     5,     6,     0,   277,     7,
     8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    42,    43,    44,    45,    46,     0,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
     0,    57,    58,    59,    60,    61,     1,    62,     2,    63,
     0,     0,     0,     0,     0,     0,     0,     0,     3,     0,
     4,     0,     0,     0,     0,     0,     0,     0,     5,     6,
     0,     0,     7,     8,     0,     0,     0,     0,     0,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,     0,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,     2,    57,    58,    59,    60,    61,   146,
    62,     0,    63,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     5,     0,     0,     0,     7,     8,    27,
    28,    29,    30,    31,    32,    33,     0,    35,    36,    37,
    38,    39,    40,    41,    42,    43,    44,    45,    46,     0,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
     0,    57,     0,     0,     0,     0,     0,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,     0,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,     0,    57,
    58,    59,    60,    61,     0,    62,     0,    63
};

static const short yycheck[] = {     4,
   206,   207,   208,     6,   316,    63,     0,    96,   209,   210,
    96,    64,    37,   107,    76,   109,    80,    58,    59,    58,
    59,    97,    89,    90,    91,    92,    64,    58,    59,   397,
    68,   228,   229,   230,   231,     3,    98,     5,   213,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   139,   419,   141,   142,   107,    23,   177,    72,    73,    27,
    28,    69,    70,    71,   140,   142,   128,     5,   112,     7,
    64,   112,    26,   112,    68,   109,    81,    82,    83,    84,
    85,    86,    87,   147,   396,   174,    80,   112,   177,   118,
    95,   180,   181,    16,   123,   184,    90,   174,   184,    87,
    67,    96,     3,   180,   181,   143,   195,    65,   146,    75,
    76,   173,   174,    74,   176,   204,   205,    74,   180,   181,
   196,   109,    23,    32,   118,   187,    27,    28,   108,   123,
   159,    16,   161,   197,   108,   109,   165,   105,    99,   100,
   101,   102,    99,   100,   101,   102,   141,   142,    32,   143,
    58,    59,   146,   147,    58,    59,   151,   211,   212,   154,
   155,   156,   238,   239,    26,   159,   255,   161,    22,    22,
   175,   165,   111,   178,   114,   108,   179,    90,   255,   174,
    26,   302,   177,   111,   111,   180,   181,   192,   193,   184,
   252,   249,   110,   198,   199,   200,   201,   202,   203,   261,
   276,   277,    22,   197,   105,   118,   412,   413,   414,    32,
   123,   386,     0,   302,   415,   416,    74,   306,   307,   308,
   309,   310,   311,   312,    88,    89,    90,    91,    92,   306,
   307,   308,   309,   310,   311,   297,    67,    69,    68,    72,
    74,    70,   100,   101,   102,    71,   159,    87,   161,   254,
    16,   256,   165,    89,    73,    91,    92,    93,   108,   114,
   255,    32,    12,   268,   108,   270,   100,   101,   102,   114,
   111,    11,    96,   108,    12,    63,    64,   398,    12,     0,
    68,     0,   189,   288,   459,   249,   375,   147,   377,   378,
   379,   380,   381,   382,   383,   197,   471,   471,   375,   459,
   377,   378,   379,   380,   381,   382,    94,   302,   429,   398,
   441,   306,   307,   308,   309,   310,   311,   141,   142,   440,
   441,   184,   411,     3,     4,     5,   411,   414,   412,    96,
    93,    94,    95,    96,    97,   413,   415,   458,   225,    88,
   429,   462,   416,    23,   226,   407,   227,    27,    28,   237,
   174,   440,   441,   177,   275,   143,   180,   181,   146,   242,
   184,   280,   275,     7,   453,   454,   428,   280,     8,   458,
    -1,     5,    -1,   462,   141,   142,   453,   454,    -1,   468,
   375,    -1,   377,   378,   379,   380,   381,   382,    -1,    -1,
    -1,   468,    -1,   388,    -1,    74,   232,   233,   234,   235,
   236,   189,    -1,   398,   409,   410,    -1,   174,    -1,   139,
   177,   141,   142,   180,   181,   420,    15,   184,     3,     4,
     5,   100,   101,   102,    -1,   105,   106,   107,    -1,   434,
    -1,   255,    31,   113,   429,    34,    -1,    36,    23,    74,
    -1,    -1,    27,    28,   174,   440,   441,    -1,    -1,    -1,
   180,   181,    -1,    15,    -1,    90,    -1,    92,   453,   454,
    22,   249,    -1,   458,    -1,   100,   101,   462,   103,    31,
    -1,    -1,    34,   468,    36,    -1,    -1,    -1,   302,    -1,
    -1,    -1,   306,   307,   308,   309,   310,   311,   255,    -1,
    -1,    -1,    -1,    -1,     3,     4,     5,   285,   286,    -1,
    18,    -1,    20,    58,    59,    60,    61,    62,    63,    64,
    -1,    -1,    67,    68,    23,    -1,    -1,    -1,    27,    28,
   105,   106,    -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,
    -1,    40,    41,    42,    43,   302,    -1,    46,    -1,   306,
   307,   308,   309,   310,   311,    54,    -1,    56,    57,    -1,
    -1,   375,    -1,   377,   378,   379,   380,   381,   382,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    -1,    -1,    -1,    -1,   398,    -1,   306,   307,   308,   309,
   310,   311,     3,     4,     5,    -1,    -1,    -1,    -1,    98,
    -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,    -1,
    -1,    -1,    23,    -1,   113,   429,    27,    28,   375,    -1,
   377,   378,   379,   380,   381,   382,   440,   441,    -1,    40,
    41,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,   453,
   454,   398,    -1,    54,   458,    56,    57,    -1,   462,    -1,
    -1,    -1,    -1,    -1,   468,   375,    -1,   377,   378,   379,
   380,   381,   382,    -1,    58,    59,    60,    61,    62,    63,
    -1,    -1,   429,    67,    68,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   440,   441,    -1,    -1,    98,    -1,    -1,
    -1,    -1,    37,    -1,   105,   106,   453,   454,    -1,    -1,
    -1,   458,    -1,    -1,    -1,   462,    -1,    -1,    -1,    -1,
    -1,   468,    -1,    58,    59,    60,    61,    62,    63,    64,
   440,   441,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   453,   454,     1,    -1,     3,     4,     5,
    -1,     7,     8,    -1,    10,    -1,    -1,    -1,   468,    15,
    -1,    17,    -1,    -1,    -1,    21,    -1,    23,    24,    -1,
    26,    27,    28,    -1,    30,    31,    -1,    -1,    34,    -1,
    36,    -1,    38,    37,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    37,    -1,    58,    59,    60,    61,    62,    63,
    64,    -1,    -1,    67,    68,    -1,    -1,    -1,    74,    -1,
    -1,    -1,    -1,    58,    59,    60,    61,    62,    63,    -1,
    -1,    -1,    67,    68,    90,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    -1,   100,   101,    -1,   103,    -1,   105,
   106,   107,    -1,    -1,   110,   111,     1,   113,     3,     4,
     5,     6,     7,     8,    -1,    10,    -1,    -1,    -1,    -1,
    15,    -1,    17,    -1,    -1,    -1,    21,    -1,    23,    -1,
    -1,    26,    27,    28,    -1,    30,    31,    -1,    -1,    34,
    -1,    36,    -1,    38,    -1,    40,    41,    42,    43,    -1,
    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    98,    -1,   100,   101,    -1,   103,    -1,
   105,   106,   107,    -1,    -1,   110,    -1,     1,   113,     3,
     4,     5,    -1,     7,     8,    -1,    10,    -1,    -1,    -1,
    -1,    15,    -1,    17,    -1,    -1,    -1,    21,    -1,    23,
    -1,    -1,    26,    27,    28,    -1,    30,    31,    -1,    -1,
    34,    -1,    36,    -1,    38,    -1,    40,    41,    42,    43,
    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    54,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    90,     0,     1,    -1,
     3,    -1,    -1,    -1,    98,    -1,   100,   101,    -1,   103,
    13,   105,   106,   107,    -1,    -1,   110,    -1,    21,   113,
    23,    24,    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    -1,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
   103,    -1,   105,    -1,   107,    -1,    -1,   110,   111,     0,
     1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    21,    -1,    23,    24,    -1,    -1,    27,    28,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
   101,   102,   103,    -1,   105,    -1,   107,    -1,    -1,    -1,
   111,     3,     4,     5,     6,    -1,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    15,    -1,    17,    -1,    -1,    -1,    21,
    -1,    23,    -1,    -1,    -1,    27,    28,    -1,    -1,    31,
    -1,    -1,    34,    -1,    36,    -1,    -1,    -1,    40,    41,
    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    54,    -1,    56,    57,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,
    -1,    -1,    -1,    -1,    -1,     1,    98,     3,   100,   101,
    -1,   103,    -1,   105,   106,   107,    -1,    13,   110,    -1,
    -1,   113,   114,    -1,    -1,    21,    -1,    23,    24,    -1,
    -1,    27,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    -1,    99,   100,   101,   102,   103,    -1,   105,
    -1,   107,    -1,    -1,    -1,   111,     3,     4,     5,     6,
    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    15,    -1,
    17,    -1,    -1,    -1,    21,    -1,    23,    -1,    -1,    26,
    27,    28,    -1,    -1,    31,    -1,    -1,    34,    -1,    36,
    -1,    -1,    -1,    40,    41,    42,    43,    -1,    -1,    46,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    56,
    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    98,    -1,   100,   101,    -1,   103,    -1,   105,   106,
   107,    -1,    -1,   110,    -1,    -1,   113,     3,     4,     5,
     6,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    15,
    -1,    17,    -1,    -1,    -1,    21,    -1,    23,    -1,    -1,
    -1,    27,    28,    -1,    -1,    31,    -1,    -1,    34,    -1,
    36,    -1,    -1,    -1,    40,    41,    42,    43,    -1,    -1,
    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,
    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    -1,   100,   101,    -1,   103,    -1,   105,
   106,   107,   108,    -1,   110,    -1,    -1,   113,     3,     4,
     5,     6,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    15,    -1,    17,    -1,    -1,    -1,    21,    -1,    23,    -1,
    -1,    -1,    27,    28,    -1,    -1,    31,    -1,    -1,    34,
    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,    -1,
    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    98,    -1,   100,   101,    -1,   103,    -1,
   105,   106,   107,   108,    -1,   110,    -1,    -1,   113,     3,
     4,     5,     6,    -1,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    15,    -1,    17,    -1,    -1,    -1,    21,    -1,    23,
    -1,    -1,    -1,    27,    28,    -1,    -1,    31,    -1,    -1,
    34,    -1,    36,    -1,    -1,    -1,    40,    41,    42,    43,
    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    54,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    98,    -1,   100,   101,    -1,   103,
    -1,   105,   106,   107,    -1,    -1,   110,    -1,   112,   113,
     3,     4,     5,     6,    -1,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    15,    -1,    17,    -1,    -1,    -1,    21,    -1,
    23,    -1,    -1,    -1,    27,    28,    -1,    -1,    31,    -1,
    -1,    34,    -1,    36,    -1,    -1,    -1,    40,    41,    42,
    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    54,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,   101,    -1,
   103,    -1,   105,   106,   107,    -1,    -1,   110,    -1,   112,
   113,     3,     4,     5,     6,    -1,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    15,    -1,    17,    -1,    -1,    -1,    21,
    -1,    23,    -1,    -1,    -1,    27,    28,    -1,    -1,    31,
    -1,    -1,    34,    -1,    36,    -1,    -1,    -1,    40,    41,
    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    54,    -1,    56,    57,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,   101,
    -1,   103,    -1,   105,   106,   107,    -1,    -1,   110,    -1,
    -1,   113,     3,     4,     5,     6,    -1,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    15,    -1,    17,    -1,    -1,    -1,
    21,    -1,    23,    -1,    -1,    -1,    27,    28,    -1,    -1,
    31,    -1,    -1,    34,    -1,    36,    -1,    -1,    -1,    40,
    41,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    54,    -1,    56,    57,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,    90,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
   101,    -1,   103,    23,   105,   106,   107,    27,    28,   110,
    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    40,    41,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    54,    -1,    56,    57,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,     3,     4,     5,    74,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    90,    23,    -1,    -1,    -1,    27,    28,    -1,    98,    -1,
   100,   101,    -1,   103,    -1,   105,   106,   107,    40,    41,
    42,    43,    -1,   113,    46,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    54,    -1,    56,    57,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     4,     5,    74,    -1,    -1,    -1,    -1,    -1,    12,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    23,
     3,     4,     5,    27,    28,    -1,    98,    -1,   100,   101,
    -1,   103,    -1,   105,   106,   107,    40,    41,    42,    43,
    23,   113,    46,    -1,    27,    28,    -1,    -1,    -1,    -1,
    54,    -1,    56,    57,    -1,    -1,    -1,    40,    41,    42,
    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    54,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,     3,     4,
     5,    -1,    -1,    -1,    98,    -1,   100,   101,    -1,   103,
    -1,   105,   106,   107,    -1,    -1,    -1,    90,    23,   113,
    -1,    -1,    27,    28,    -1,    98,    -1,   100,   101,    -1,
   103,    -1,   105,   106,   107,    40,    41,    42,    43,    -1,
   113,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,     0,     1,    -1,     3,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    98,    -1,    13,    -1,    -1,    -1,   104,
   105,   106,   107,    21,    -1,    23,    24,    -1,   113,    27,
    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    -1,    99,   100,   101,   102,   103,     1,   105,     3,   107,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,
    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    -1,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    -1,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    97,     3,    99,   100,   101,   102,   103,   110,
   105,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    23,    -1,    -1,    -1,    27,    28,    67,
    68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    -1,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    -1,    99,    -1,    -1,    -1,    -1,    -1,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
   100,   101,   102,   103,    -1,   105,    -1,   107
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 89 "mm_parser.y"
{ mm_parse_result=
				     sequence (symbol ("declare!"), yyvsp[0]); ;
    break;}
case 2:
#line 96 "mm_parser.y"
{ yyerrok; yyval = symbol ("error!"); ;
    break;}
case 3:
#line 97 "mm_parser.y"
{ yyval = extend (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 4:
#line 98 "mm_parser.y"
{ yyval = extend (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 5:
#line 99 "mm_parser.y"
{ yyval = extend (list (yyvsp[-2], yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 6:
#line 100 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 7:
#line 101 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 8:
#line 102 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 9:
#line 105 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 10:
#line 106 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 11:
#line 109 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 12:
#line 110 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 13:
#line 111 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 14:
#line 112 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 15:
#line 113 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 16:
#line 114 "mm_parser.y"
{ yyval = cons (symbol ("tuple!", yyvsp[-2]), yyvsp[-1]);
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 17:
#line 116 "mm_parser.y"
{ yyval = extend (cons (yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 18:
#line 119 "mm_parser.y"
{ yyval = list (yyvsp[0]); ;
    break;}
case 19:
#line 120 "mm_parser.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); ;
    break;}
case 20:
#line 123 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 21:
#line 124 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 22:
#line 127 "mm_parser.y"
{ yyval = list (); ;
    break;}
case 23:
#line 128 "mm_parser.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); ;
    break;}
case 24:
#line 129 "mm_parser.y"
{ yyval = apply_all (yyvsp[-1], as_list (yyvsp[0])); ;
    break;}
case 25:
#line 130 "mm_parser.y"
{ yyval = apply_all (yyvsp[-3], as_list (yyvsp[-1]));
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 26:
#line 134 "mm_parser.y"
{ yyval = list (symbol ("mod!"), yyvsp[0]); ;
    break;}
case 27:
#line 135 "mm_parser.y"
{ yyval = list (symbol ("mod!"), yyvsp[0]); ;
    break;}
case 28:
#line 136 "mm_parser.y"
{ yyval = list (symbol ("mod!"), yyvsp[-2], yyvsp[-1]);
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 29:
#line 140 "mm_parser.y"
{ yyval = extend (extend (yyvsp[-1], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 30:
#line 141 "mm_parser.y"
{ yyval = apply_all (yyvsp[-1], as_list (yyvsp[0])); ;
    break;}
case 31:
#line 144 "mm_parser.y"
{ yyval = sequence (symbol ("declare!"), yyvsp[0]); ;
    break;}
case 32:
#line 151 "mm_parser.y"
{ yyerrok; yyval = symbol ("error!"); ;
    break;}
case 33:
#line 152 "mm_parser.y"
{ yyval = extend (yyvsp[-1], yyvsp[0]); ;
    break;}
case 34:
#line 153 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 35:
#line 154 "mm_parser.y"
{ yyval = if_then (yyvsp[-3], yyvsp[-2], yyvsp[0]); ;
    break;}
case 36:
#line 155 "mm_parser.y"
{ yyval = list (yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); ;
    break;}
case 37:
#line 156 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 38:
#line 157 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 39:
#line 158 "mm_parser.y"
{ yyval = list (yyvsp[-3], yyvsp[-2], yyvsp[0]); ;
    break;}
case 40:
#line 159 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 41:
#line 160 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 42:
#line 161 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 43:
#line 162 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 44:
#line 163 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 45:
#line 164 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 46:
#line 165 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 47:
#line 166 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 48:
#line 167 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 49:
#line 168 "mm_parser.y"
{ yyval = extend (list (yyvsp[-1]), yyvsp[0]); ;
    break;}
case 50:
#line 169 "mm_parser.y"
{ yyval = extend (list (yyvsp[-1]), yyvsp[0]); ;
    break;}
case 51:
#line 170 "mm_parser.y"
{ yyval = extend (list (yyvsp[-1]), yyvsp[0]); ;
    break;}
case 52:
#line 171 "mm_parser.y"
{ yyval = extend (list (yyvsp[-1]), yyvsp[0]); ;
    break;}
case 53:
#line 174 "mm_parser.y"
{ yyval = list (); ;
    break;}
case 54:
#line 175 "mm_parser.y"
{ yyval = cons (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 55:
#line 176 "mm_parser.y"
{ yyval = cons (list (yyvsp[-4], yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 56:
#line 177 "mm_parser.y"
{ yyval = cons (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 57:
#line 178 "mm_parser.y"
{ yyval = cons (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 58:
#line 179 "mm_parser.y"
{ yyval = cons (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 59:
#line 182 "mm_parser.y"
{ yyval = extend (extend (yyvsp[-1], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 60:
#line 185 "mm_parser.y"
{ yyval = list (); ;
    break;}
case 61:
#line 186 "mm_parser.y"
{ yyval = list (generic (list (yyvsp[-1], yyvsp[0]))); ;
    break;}
case 62:
#line 187 "mm_parser.y"
{ yyval = cons (list (yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 63:
#line 190 "mm_parser.y"
{ yyval = list (yyvsp[0]); ;
    break;}
case 64:
#line 191 "mm_parser.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); ;
    break;}
case 65:
#line 194 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 66:
#line 195 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 67:
#line 198 "mm_parser.y"
{ yyval = list (); ;
    break;}
case 68:
#line 199 "mm_parser.y"
{ yyval = list (); ;
    break;}
case 69:
#line 202 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 70:
#line 203 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 71:
#line 206 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 72:
#line 207 "mm_parser.y"
{ yyval = extend (list (yyvsp[-2], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 73:
#line 208 "mm_parser.y"
{ yyval = extend (list (yyvsp[-2], yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 74:
#line 209 "mm_parser.y"
{ yyval = list (yyvsp[-1], list (yyvsp[-3], yyvsp[-4], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 75:
#line 210 "mm_parser.y"
{ yyval = list (yyvsp[-1], list (yyvsp[-3], yyvsp[-4], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 76:
#line 211 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 77:
#line 214 "mm_parser.y"
{ yyval = list (); ;
    break;}
case 78:
#line 215 "mm_parser.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); ;
    break;}
case 79:
#line 218 "mm_parser.y"
{ yyval = sequence (symbol ("begin!", yyvsp[-2]), yyvsp[-1]);
                                   yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 80:
#line 226 "mm_parser.y"
{ yyval = extend (yyvsp[-1], yyvsp[0]); ;
    break;}
case 81:
#line 227 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 82:
#line 228 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 83:
#line 229 "mm_parser.y"
{ yyval = list (yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); ;
    break;}
case 84:
#line 230 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 85:
#line 231 "mm_parser.y"
{ yyval = list (yyvsp[-3], yyvsp[-2], yyvsp[0]); ;
    break;}
case 86:
#line 232 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 87:
#line 233 "mm_parser.y"
{ yyval = list (yyvsp[-2], yyvsp[-3], yyvsp[-1]); ;
    break;}
case 88:
#line 234 "mm_parser.y"
{ yyval = list (yyvsp[-1], list (yyvsp[-3], yyvsp[-4], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 89:
#line 235 "mm_parser.y"
{ yyval = list (yyvsp[-1], list (yyvsp[-3], yyvsp[-4], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 90:
#line 236 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 91:
#line 237 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 92:
#line 238 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 93:
#line 239 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 94:
#line 240 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 95:
#line 241 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 96:
#line 248 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 97:
#line 249 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 98:
#line 250 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 99:
#line 251 "mm_parser.y"
{ yyval = list (yyvsp[-5], yyvsp[-4], yyvsp[-2], yyvsp[0]); ;
    break;}
case 100:
#line 252 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 101:
#line 253 "mm_parser.y"
{ yyval = list (yyvsp[-3], yyvsp[-2], yyvsp[0]); ;
    break;}
case 102:
#line 254 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 103:
#line 255 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 104:
#line 256 "mm_parser.y"
{ yyval = list (yyvsp[-1], list (yyvsp[-3], yyvsp[-4], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 105:
#line 257 "mm_parser.y"
{ yyval = list (yyvsp[-1], list (yyvsp[-3], yyvsp[-4], yyvsp[-2]), yyvsp[0]); ;
    break;}
case 106:
#line 258 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 107:
#line 259 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 108:
#line 260 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 109:
#line 261 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 110:
#line 262 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 111:
#line 263 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 112:
#line 266 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 113:
#line 267 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 114:
#line 268 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 115:
#line 271 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 116:
#line 272 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 117:
#line 275 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 118:
#line 276 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 119:
#line 279 "mm_parser.y"
{ yyval= list (); ;
    break;}
case 120:
#line 280 "mm_parser.y"
{ yyval= cons (yyvsp[-1], yyvsp[0]); ;
    break;}
case 121:
#line 283 "mm_parser.y"
{ yyval= list (); ;
    break;}
case 122:
#line 284 "mm_parser.y"
{ yyval= cons (yyvsp[-1], yyvsp[0]); ;
    break;}
case 123:
#line 291 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 124:
#line 292 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 125:
#line 293 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 126:
#line 294 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 127:
#line 297 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 128:
#line 298 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 129:
#line 301 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 130:
#line 302 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 131:
#line 305 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 132:
#line 306 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 133:
#line 309 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 134:
#line 310 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 135:
#line 311 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 136:
#line 314 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 137:
#line 315 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 138:
#line 318 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 139:
#line 319 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 140:
#line 322 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 141:
#line 323 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 142:
#line 326 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 143:
#line 327 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 144:
#line 328 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 145:
#line 331 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 146:
#line 332 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 147:
#line 333 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 148:
#line 334 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 149:
#line 335 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 150:
#line 336 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 151:
#line 337 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 152:
#line 338 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 153:
#line 339 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 154:
#line 340 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 155:
#line 341 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 156:
#line 342 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 157:
#line 343 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 158:
#line 350 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 159:
#line 351 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 160:
#line 354 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 161:
#line 355 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 162:
#line 358 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 163:
#line 359 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 164:
#line 362 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 165:
#line 363 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 166:
#line 364 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 167:
#line 365 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 168:
#line 366 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 169:
#line 369 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 170:
#line 370 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 171:
#line 371 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 172:
#line 372 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 173:
#line 373 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 174:
#line 374 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 175:
#line 377 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 176:
#line 378 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 177:
#line 379 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 178:
#line 380 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 179:
#line 381 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 180:
#line 388 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 181:
#line 389 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 182:
#line 390 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 183:
#line 391 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 184:
#line 394 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 185:
#line 395 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 186:
#line 396 "mm_parser.y"
{ yyval = extend (cons (yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 187:
#line 397 "mm_parser.y"
{ yyval = cons (symbol (".[]", yyvsp[-2]), yyvsp[-3], yyvsp[-1]);
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 188:
#line 401 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 189:
#line 402 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 190:
#line 405 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 191:
#line 406 "mm_parser.y"
{ yyval = list (symbol (".++", yyvsp[0]), yyvsp[-1]); ;
    break;}
case 192:
#line 407 "mm_parser.y"
{ yyval = list (symbol (".--", yyvsp[0]), yyvsp[-1]); ;
    break;}
case 193:
#line 408 "mm_parser.y"
{ yyval = list (symbol (".!", yyvsp[0]), yyvsp[-1]); ;
    break;}
case 194:
#line 409 "mm_parser.y"
{ yyval = list (yyvsp[0], yyvsp[-1]); ;
    break;}
case 195:
#line 412 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 196:
#line 413 "mm_parser.y"
{ yyval = list (symbol ("tuple!", yyvsp[-1]));
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 197:
#line 415 "mm_parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 198:
#line 416 "mm_parser.y"
{ yyval = cons (symbol ("tuple!", yyvsp[-5]), yyvsp[-4],yyvsp[-2],yyvsp[-1]);
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 199:
#line 418 "mm_parser.y"
{ yyval = cons (symbol ("[]", yyvsp[-2]), yyvsp[-1]);
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 200:
#line 422 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 201:
#line 423 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 202:
#line 424 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 203:
#line 425 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[0]); ;
    break;}
case 204:
#line 428 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 205:
#line 429 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 206:
#line 430 "mm_parser.y"
{ yyval = extend (cons (yyvsp[-3], yyvsp[-1]), yyvsp[0]); ;
    break;}
case 207:
#line 431 "mm_parser.y"
{ yyval = cons (symbol (".[]", yyvsp[-2]), yyvsp[-3], yyvsp[-1]);
	                           yyval = extend (yyval, yyvsp[0]); ;
    break;}
case 208:
#line 435 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 209:
#line 436 "mm_parser.y"
{ yyval = list (yyvsp[-1], yyvsp[-2], yyvsp[0]); ;
    break;}
case 210:
#line 439 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 211:
#line 440 "mm_parser.y"
{ yyval = list (symbol (".++", yyvsp[0]), yyvsp[-1]); ;
    break;}
case 212:
#line 441 "mm_parser.y"
{ yyval = list (symbol (".--", yyvsp[0]), yyvsp[-1]); ;
    break;}
case 213:
#line 442 "mm_parser.y"
{ yyval = list (symbol (".!", yyvsp[0]), yyvsp[-1]); ;
    break;}
case 214:
#line 443 "mm_parser.y"
{ yyval = list (yyvsp[0], yyvsp[-1]); ;
    break;}
case 215:
#line 446 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 216:
#line 447 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 217:
#line 448 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 218:
#line 449 "mm_parser.y"
{ yyval = list (yyvsp[-3], yyvsp[-2], yyvsp[0]); ;
    break;}
case 219:
#line 450 "mm_parser.y"
{ yyval = list (yyvsp[-3], yyvsp[-2], yyvsp[0]); ;
    break;}
case 220:
#line 457 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 221:
#line 458 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 222:
#line 459 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 223:
#line 460 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 224:
#line 461 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 225:
#line 462 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 226:
#line 463 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 227:
#line 464 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 228:
#line 465 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 229:
#line 466 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 230:
#line 469 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 231:
#line 470 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 232:
#line 471 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 233:
#line 472 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 234:
#line 473 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 235:
#line 474 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 236:
#line 475 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 237:
#line 476 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 238:
#line 483 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 239:
#line 484 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 240:
#line 485 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 241:
#line 486 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 242:
#line 487 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 243:
#line 488 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 244:
#line 489 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 245:
#line 492 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 246:
#line 493 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 247:
#line 494 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 248:
#line 495 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 249:
#line 498 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 250:
#line 501 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 251:
#line 502 "mm_parser.y"
{ yyval = symbol (".!", yyvsp[0]); ;
    break;}
case 252:
#line 503 "mm_parser.y"
{ yyval = symbol (".++", yyvsp[0]); ;
    break;}
case 253:
#line 504 "mm_parser.y"
{ yyval = symbol (".--", yyvsp[0]); ;
    break;}
case 254:
#line 507 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 255:
#line 508 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 256:
#line 509 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 257:
#line 510 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 258:
#line 511 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 259:
#line 512 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 260:
#line 513 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 261:
#line 514 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 262:
#line 515 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 263:
#line 516 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 264:
#line 517 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 265:
#line 518 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 266:
#line 519 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 267:
#line 520 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 268:
#line 521 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 269:
#line 522 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 270:
#line 523 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 271:
#line 524 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 272:
#line 525 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 273:
#line 526 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 274:
#line 527 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 275:
#line 528 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 276:
#line 529 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 277:
#line 530 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 278:
#line 531 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 279:
#line 532 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 280:
#line 533 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 281:
#line 534 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 282:
#line 537 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 283:
#line 538 "mm_parser.y"
{ yyval = yyvsp[0]; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 541 "mm_parser.y"


/******************************************************************************
* Finalize certain constructions
******************************************************************************/

static generic
if_then (generic g_if, generic g_cond, generic g_arg) {
  generic g= list (g_if, g_cond, g_arg);
  if ((N (g_arg) == 4) && (car (g_arg) == symbol ("if!"))) {
    generic g_else = g_arg[3];
    mm_warning ("dangling else", g_else);
  }
  return g;
}

static int
status (generic g) {
  if ((N(g) == 2) && (N(g[0]) >= 2) && (g[0][0] == symbol ("mod!")))
    return status (g[1]);
  if ((N(g) == 3) && (g[0] == symbol (":"))) return 1;
  if ((N(g) == 3) && ((g[0] == symbol ("==")) || (g[0] == symbol (":="))))
    if ((N(g[1]) == 3) && (g[1][0] == symbol (":"))) return 1;
  if ((N(g) == 2) && (g[0] == symbol ("import!"))) return 2;
  if ((N(g) == 2) && (g[0] == symbol ("export!"))) return 2;
  return 0;
}

static generic
rewrite (generic g) {
  if ((N(g) == 2) && (N(g[0]) >= 2) && (g[0][0] == symbol ("mod!")))
    return list ((N(g[0])==2 ? g[0][1]: cdr (g[0])), rewrite (g[1]));
  else return g;
}

static generic
sequence (generic g_op, generic g_arg) {
  if (nil (g_arg)) return list (g_op);
  if (car (g_arg) == symbol ("error!"))
    return sequence (g_op, cdr (g_arg));

  generic item= rewrite (car (g_arg));
  generic next= sequence (g_op, cdr (g_arg));
  generic head= car (next);
  generic tail= cdr (next);

  switch (status (car (g_arg))) {
  case 0:
    if (head == symbol ("begin!"))
      return cons (symbol ("begin!", g_op), item, tail);
    return list (symbol ("begin!", g_op), item, next);
  case 1:
    if (head == symbol ("declare!"))
      return cons (symbol ("declare!", g_op), item, tail);
    if (head == symbol ("local!"))
      return cons (symbol ("local!", g_op), item, tail);
    return list (symbol ("local!", g_op), item, next);
  case 2:
    if (head == symbol ("migrate!"))
      return cons (symbol ("migrate!", g_op), item, tail);
    return list (symbol ("migrate!", g_op), item, next);
  }

  fatal_error ("unexpected situation", "sequence", "mm_parser.y");
}

/******************************************************************************
* Exported parsing functions
******************************************************************************/

void
mm_warning (char* s, generic where) {
  generic war= std_warning (string (s), where);
  mm_parse_errors= cons (war, mm_parse_errors);
}

void
mm_error (char* s) {
  int pos1= mm_lex_origin + mm_lex_prev;
  int pos2= mm_lex_origin + mm_lex_pos;
  generic err= std_error (string (s), symbol ("", pos1, pos2));
  mm_parse_errors= cons (err, mm_parse_errors);
}

generic
mm_parse (string s, list& errors) {
  start_lexer (s);
  mm_parse_result= generic ();
  mm_parse_errors= list ();
  mm_parse ();
  errors= mm_parse_errors;
  return mm_parse_result;
}
