
/******************************************************************************
* MODULE     : test4.cc
* DESCRIPTION: Test mirrors
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <string.hh>
#include <mirror.hh>

int
main () {
  string a ("a");
  string b ("b");
  generic m1= mirror (a);
  generic m2= mirror (a);
  generic m3= mirror (b);
  cout << "m1= " << m1 << "\n";
  cout << "m2= " << m2 << "\n";
  cout << "m3= " << m3 << "\n";
  cout << "m1=m2? " << (m1==m2) << "\n";
  cout << "m1=m3? " << (m1==m3) << "\n";
  cout << "m2=m3? " << (m2==m3) << "\n";
  cout << "m1=m1? " << (m1==m1) << "\n";
  return 0;
}
