
/******************************************************************************
* MODULE     : lazy_class.cc
* DESCRIPTION: Lazy compilation of classs
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <lazy.hh>

class lazy_class_rep: public lazy_rep {
public:
  lazy_class_rep (context con, generic g);
  bool compile_this (bool force);
};

lazy_class_rep::lazy_class_rep (context con, generic g):
  lazy_rep (con, g) {}

bool
lazy_class_rep::compile_this (bool force) { (void) force;
  meaning (con->get_class (), con->get_signature ());
  return TRUE;
}

generic
make_lazy_class (generic g) {
  return lazy (new lazy_class_rep (as_context (g[0]), g[1]));
}
