
/******************************************************************************
* MODULE     : file.hh
* DESCRIPTION: Loading and saving files
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __FILE_HH
#define __FILE_HH
#include <string.hh>

void insert_source (string& src, string name);
void find_location (int loc, string& src, string& name, int& row, int& col);

bool load (string file_name, string& s, bool decode= TRUE);
bool save (string file_name, string s, bool decode= TRUE);

#endif // __FILE_HH
